image: code.europa.eu:4567/simpl/simpl-open/testing/sandbox-clean-code:latest

variables:
  POSTGRES_DB: spring-boot
  POSTGRES_USER: admin
  POSTGRES_PASSWORD: $POSTGRES_PASSWORD
  DB_URL: jdbc:postgresql://localhost:5432/spring-boot
  DB_USERNAME: $POSTGRES_USER
  DB_DRIVER: org.postgresql.Driver
  DB_PASSWORD: $POSTGRES_PASSWORD

stages:
  - build
  - quality-testing
  - checkstyle
  - test
  - report
  - package

cache:
  paths:
    - /home/postgres/.m2/repository

before_script:
  - export MAVEN_CONFIG="/home/postgres/.m2"
  - export MAVEN_OPTS="-Dmaven.repo.local=/home/postgres/.m2/repository"
  - echo "Starting PostgreSQL..."
  - pg_ctl start -D /var/lib/postgresql/data -l /var/lib/postgresql/data/logfile
  - >
    timeout 300s bash -c '
    until pg_isready -h localhost -p 5432 -U $POSTGRES_USER -d $POSTGRES_DB; do
      echo "waiting for database...";
      sleep 2;
    done'
  - echo "Database is ready!"

.sonar-base:
  stage: quality-testing
  script:
    - sonar-scanner $SONAR_OPTS_BASE $SONAR_OPTS_JAVA $SONAR_OPTS_JAVASCRIPT
  artifacts:
    paths:
      - .sonar
    when: always
  rules:
    - if: $CI_COMMIT_BRANCH == "main" || $CI_COMMIT_BRANCH == "develop"

build:
  stage: build
  script:
    - mvn dependency:go-offline
  artifacts:
    paths:
      - /home/postgres/.m2/repository

sonarqube:
  extends: .sonar-base

checkstyle:
  stage: checkstyle
  script:
    - mvn jxr:jxr jxr:test-jxr checkstyle:checkstyle
  artifacts:
    paths:
      - target/site
    when: always

test:
  stage: test
  script:
    - mvn clean test
  only:
    - main
    - develop
  artifacts:
    paths:
      - target/surefire-reports
      - allure-results
    reports:
      junit: target/surefire-reports/*.xml
    when: always

report:
  stage: report
  script:
    - mvn allure:report
    - mvn allure:aggregate
    - zip -r allure-report.zip allure-report
  artifacts:
    paths:
      - allure-report.zip
    when: always

package:
  stage: package
  script:
    - mkdir -p test_reports/allure
    - mkdir -p test_reports/checkstyle
    - mv allure-report.zip test_reports/allure/
    - cp -r target/site/* test_reports/checkstyle/
    - cd test_reports && zip -r test_reports.zip .
  artifacts:
    paths:
      - test_reports/test_reports.zip
    when: always
